"use strict";

module.exports = function ({
  types : t
}) {
  return {
    name: "ctf-quick",
    visitor: {
      Program(path,state){
        appuxImport(path,state)
      },
      BlockStatement(path,state){
        BlockStatement_maidianOpr(path,state)
      }
    }
  };
  function appuxImport(path,state){
    if(!/app\.ux/.test(state.file.opts.filename)){
      return
    }
    path.node.body.push(
      t.importDeclaration([],t.stringLiteral(state.opts.minitickPath))
    );
  }
  function BlockStatement_maidianOpr(path,state){
    let filename = state.file.opts.filename;
    if(!(/(\.ux$)|^(?!.*node_modules.*\.js).*\.js$/.test(filename))){
      return
    }
    let b = path.node.body;
    if(!b[0]){
      //no body node but has innerComments
      let innerComments = path.node.innerComments;
      if(innerComments){
        let nodes = getSamePlaceCommentToFunc(innerComments,state.opts.injectMap);
        nodes.length>0&&b.splice(0,0,...nodes);
      }
      return
    }
    // first filter the first statement whether who has leadingcomments
    let firseLeading = b[0].leadingComments;
    let firstFncarr = getSamePlaceCommentToFunc(firseLeading,state.opts.injectMap);
    firstFncarr.length>0 && (b.splice(0,0,...firstFncarr));
     //then handle every statement whether who has trailingcomments
     for(let i=0,len=b.length;i<len;i++){
        let trailFnarr = getSamePlaceCommentToFunc(b[i].trailingComments,state.opts.injectMap);
        let newLen = trailFnarr.length;
        if(newLen>0) {
            b.splice(i+1,0,...trailFnarr);
            i+=newLen; //do this because b has changed
            len+=newLen; // Same as above
        }
    }
  }
  function getSamePlaceCommentToFunc(comments,injectMap){
    let reg = /^\[(.+)\]/;
    let info = [];
    if (!comments) {
        return [];
    }
    for (let i = 0, len = comments.length; i < len; i++) {
        let val = comments[i].value.trim();
        let matchres = val.match(reg);
        if (matchres) {
            info.push({
                type: matchres[1],
                params: val.split(":")[1] || ""
            })
        }
    }
    if (info.length <= 0) {
        return [];
    }
    let samePlace_nodearr=[];
    for (let i = 0, len = info.length; i < len; i++) {
        samePlace_nodearr.push(singleInsetNodeFn(info[i],injectMap))
    }
    return samePlace_nodearr;
  }
  function singleInsetNodeFn(info = {
      type: '埋点',
      params: "haha"
  },injectMap) {
      let { type, params } = info
      console.log({type,params})
      //判断info是常量还是变量
      let infonode = params?params.split('-').map(info => {
          return /^\$/.test(info) ? t.identifier(info.slice(1)) : t.stringLiteral(info);
      }):[];
    return t.expressionStatement(t.callExpression(t.identifier(injectMap[type]), infonode));
  }
};